diff --git a/tests/manager/test_all.py b/tests/manager/test_all.py
index bb756887..3d29c922 100644
--- a/tests/manager/test_all.py
+++ b/tests/manager/test_all.py
@@ -1997,6 +2543,129 @@ def test_virtual_agenda_day_view(app, admin_user, manager_user, get_proper_html_
     assert 'exceptions-hours' not in resp.text
 
 
+def test_virtual_agenda_week_view(app, admin_user, get_proper_html_str):
+    agenda = Agenda.objects.create(label='Virtual', kind='virtual')
+    real_agenda_1 = Agenda.objects.create(label='Real 1', kind='meetings')
+    real_agenda_2 = Agenda.objects.create(label='Real 2', kind='meetings')
+    VirtualMember.objects.create(virtual_agenda=agenda, real_agenda=real_agenda_1)
+    VirtualMember.objects.create(virtual_agenda=agenda, real_agenda=real_agenda_2)
+
+    desk1 = Desk.objects.create(agenda=real_agenda_1, label='New Desk')
+    desk2 = Desk.objects.create(agenda=real_agenda_2, label='New Desk')
+    today = datetime.date.today()
+
+    meetingtype1 = MeetingType.objects.create(agenda=real_agenda_1, label='Bar', duration=30)
+    meetingtype2 = MeetingType.objects.create(agenda=real_agenda_2, label='Bar', duration=30)
+
+    login(app)
+    resp = app.get('/manage/agendas/%s/%d/%d/%d/' % (agenda.pk, today.year, today.month, today.day))
+    assert 'Week view' in resp.text
+    resp = resp.click('Week view')
+    assert resp.request.url.endswith('%s/week/%s/' % (today.year, today.strftime('%W')))
+
+    assert 'Day view' in resp.text  # day view link should be present
+    assert 'Month view' in resp.text  # month view link should be present
+    assert 'No opening hours this week.' in resp.text
+
+    today = datetime.date(2018, 11, 10)  # fixed day
+    timeperiod_weekday = today.weekday()
+    TimePeriod.objects.create(
+        desk=desk1, weekday=timeperiod_weekday, start_time=datetime.time(10, 0), end_time=datetime.time(18, 0)
+    )
+    resp = app.get('/manage/agendas/%s/%s/week/%s/' % (agenda.id, today.year, today.strftime('%W')))
+    assert 'No opening hours this week.' not in resp.text
+    assert '<div class="booking' not in resp.text
+    assert resp.text.count('<tr') == 9
+
+    # check opening hours cells
+    assert '<div class="opening-hours" style="height:800.0%;top:0.0%;width:48.0%;left:1.0%' in resp.text
+
+    # book some slots
+    for hour, minute in [(10, 30), (14, 0)]:
+        event = Event.objects.create(
+            agenda=real_agenda_1,
+            places=1,
+            desk=desk1,
+            meeting_type=meetingtype1,
+            start_datetime=now().replace(hour=hour, minute=minute),
+        )
+        Booking.objects.create(event=event)
+        event = Event.objects.create(
+            agenda=real_agenda_2,
+            places=1,
+            desk=desk2,
+            meeting_type=meetingtype2,
+            start_datetime=now().replace(hour=hour, minute=minute),
+        )
+        Booking.objects.create(event=event, label='foo', user_last_name="bar's")
+
+    date = Booking.objects.all()[0].event.start_datetime
+    resp = app.get('/manage/agendas/%s/%d/week/%s/' % (agenda.id, date.year, date.strftime('%W')))
+    assert resp.text.count('<div class="booking" style="left:1.0%;height:50.0%;') == 2  # booking cells
+    assert (
+        resp.text.count('<div class="booking" style="left:50.0%;height:50.0%;min-height:50.0%;') == 2
+    )  # booking cells
+    assert resp.pyquery.find('div.booking a').not_('.cancel')[0].text.strip() == 'booked'
+    assert resp.pyquery.find('div.booking a').not_('.cancel')[1].text.strip() == "foo - bar's"
+    assert resp.pyquery.find('div.booking a').not_('.cancel')[2].text.strip() == 'booked'
+    assert resp.pyquery.find('div.booking a').not_('.cancel')[3].text.strip() == "foo - bar's"
+    assert get_proper_html_str('foo - bar&#39;s') in resp
+
+    real_agenda_1.booking_user_block_template = '<b>{{ booking.user_name }}</b> Foo Bar'
+    real_agenda_1.save()
+    real_agenda_2.booking_user_block_template = '<b>{{ booking.user_name }}</b> Bar Foo'
+    real_agenda_2.save()
+    resp = app.get('/manage/agendas/%s/%d/%d/' % (agenda.id, date.year, date.month))
+    assert resp.pyquery.find('div.booking a').not_('.cancel')[0].text.strip() == '<b></b> Foo Bar'
+    assert resp.pyquery.find('div.booking a').not_('.cancel')[1].text.strip() == "<b>bar's</b> Bar Foo"
+    assert resp.pyquery.find('div.booking a').not_('.cancel')[2].text.strip() == '<b></b> Foo Bar'
+    assert resp.pyquery.find('div.booking a').not_('.cancel')[3].text.strip() == "<b>bar's</b> Bar Foo"
+    assert get_proper_html_str('&lt;b&gt;bar&#39;s&lt;/b&gt; Bar Foo') in resp
+
+    # cancel a booking
+    booking = Booking.objects.first()
+    booking.cancel()
+    resp = app.get('/manage/agendas/%s/%d/week/%s/' % (agenda.id, date.year, date.strftime('%W')))
+    assert resp.text.count('<div class="booking"') == 3
+
+    # check December is correctly displayed
+    today = datetime.date(2018, 12, 10)
+    resp = app.get('/manage/agendas/%s/%d/week/%s/' % (agenda.id, today.year, today.strftime('%W')))
+    assert 'No opening hours this month.' not in resp.text
+
+    # display exception
+    TimePeriodException.objects.create(
+        label='Exception for a December day',
+        desk=desk1,
+        start_datetime=make_aware(datetime.datetime(2018, 12, 15, 5, 0)),
+        end_datetime=make_aware(datetime.datetime(2018, 12, 15, 23, 0)),
+    )
+    with CaptureQueriesContext(connection) as ctx:
+        resp = app.get('/manage/agendas/%s/%d/week/%s/' % (agenda.id, today.year, today.strftime('%W')))
+        assert len(ctx.captured_queries) == 12
+    assert len(resp.pyquery.find('.exception-hours')) == 1
+    assert resp.pyquery.find('.exception-hours')[0].attrib == {
+        'class': 'exception-hours',
+        'style': 'height:800.0%;top:0.0%;width:48.0%;left:1.0%;',
+        'title': 'Exception for a December day',
+    }
+
+    # display excluded period
+    TimePeriod.objects.create(
+        agenda=agenda, weekday=today.weekday(), start_time=datetime.time(13, 0), end_time=datetime.time(23, 0)
+    )
+    resp = app.get('/manage/agendas/%s/%d/week/%s/' % (agenda.id, today.year, today.strftime('%W')))
+    assert len(resp.pyquery.find('.exception-hours')) == 3
+    assert resp.pyquery.find('.exception-hours')[0].attrib == {
+        'class': 'exception-hours',
+        'style': 'height:500.0%;top:300.0%;width:48.0%;left:1.0%;',
+    }
+    assert resp.pyquery.find('.exception-hours')[1].attrib == {
+        'class': 'exception-hours',
+        'style': 'height:500.0%;top:300.0%;width:48.0%;left:50.0%;',
+    }
+
+
 def test_virtual_agenda_month_view(app, admin_user, get_proper_html_str):
     agenda = Agenda.objects.create(label='Virtual', kind='virtual')
     real_agenda_1 = Agenda.objects.create(label='Real 1', kind='meetings')
@@ -2017,7 +2686,8 @@ def test_virtual_agenda_month_view(app, admin_user, get_proper_html_str):
     resp = resp.click('Month view')
     assert resp.request.url.endswith('%s/%s/' % (today.year, today.month))
 
-    assert 'Day view' in resp.text  # date view link should be present
+    assert 'Day view' in resp.text  # day view link should be present
+    assert 'Week view' in resp.text  # week view link should be present
     assert 'No opening hours this month.' in resp.text
 
     today = datetime.date(2018, 11, 10)  # fixed day
diff --git a/tests/manager/test_resource.py b/tests/manager/test_resource.py
index c634815c..9d92c3fd 100644
--- a/tests/manager/test_resource.py
+++ b/tests/manager/test_resource.py
@@ -220,6 +220,296 @@ def test_day_view_resource_as_manager(app, manager_user):
     app.get('/manage/resource/%s/%d/%d/%d/' % (resource.pk, today.year, today.month, today.day), status=403)
 
 
+@freezegun.freeze_time('2020-06-15')
+def test_resource_week_view(app, admin_user, get_proper_html_str):
+    resource = Resource.objects.create(label='Foo bar')
+    agenda = Agenda.objects.create(label='Agenda', kind='meetings')
+    agenda.resources.add(resource)
+    desk = Desk.objects.create(agenda=agenda, label='Desk')
+    meetingtype = MeetingType.objects.create(agenda=agenda, label='Bar', duration=20)
+    TimePeriod.objects.create(
+        desk=desk, weekday=0, start_time=datetime.time(10, 0), end_time=datetime.time(18, 0)
+    )
+
+    login(app)
+    today = datetime.date(2018, 11, 10)  # fixed day
+    app.get('/manage/resource/%s/%s/%s/' % (resource.pk, today.year, 72), status=404)
+    resp = app.get('/manage/resource/%s/%s/week/%s/' % (resource.pk, today.year, today.strftime('%W')))
+    assert '<div class="booking' not in resp.text
+    assert resp.text.count('<tr') == 9
+
+    # book some slots
+    for hour, minute in [(10, 30), (14, 0)]:
+        event = Event.objects.create(
+            agenda=agenda,
+            places=1,
+            desk=desk,
+            meeting_type=meetingtype,
+            start_datetime=now().replace(hour=hour, minute=minute),
+        )
+        event.resources.add(resource)
+        if hour == 10:
+            Booking.objects.create(event=event)
+        else:
+            Booking.objects.create(event=event, label='foo', user_last_name="bar's")
+
+    today = datetime.date.today()
+    with CaptureQueriesContext(connection) as ctx:
+        resp = app.get('/manage/resource/%s/%s/week/%s/' % (resource.pk, today.year, today.strftime('%W')))
+        assert len(ctx.captured_queries) == 8
+    assert resp.text.count('<div class="booking" style="height:33.0%;') == 2  # booking cells
+    assert resp.pyquery.find('div.booking a').not_('.cancel')[0].text.strip() == 'booked'
+    assert resp.pyquery.find('div.booking a').not_('.cancel')[1].text.strip() == "foo - bar's"
+    assert get_proper_html_str('foo - bar&#39;s') in resp
+
+    agenda.booking_user_block_template = '<b>{{ booking.user_name }}</b> Foo Bar'
+    agenda.save()
+    resp = app.get('/manage/resource/%s/%s/week/%s/' % (resource.pk, today.year, today.strftime('%W')))
+    assert resp.pyquery.find('div.booking a').not_('.cancel')[0].text.strip() == '<b></b> Foo Bar'
+    assert resp.pyquery.find('div.booking a').not_('.cancel')[1].text.strip() == "<b>bar's</b> Foo Bar"
+    assert get_proper_html_str('&lt;b&gt;bar&#39;s&lt;/b&gt; Foo Bar') in resp
+
+    # cancel booking
+    booking = Booking.objects.first()
+    booking.cancel()
+
+    # make sure the are not
+    resp = app.get('/manage/resource/%s/%s/week/%s/' % (resource.pk, today.year, today.strftime('%W')))
+    assert resp.text.count('<div class="booking"') == 1
+
+
+def test_resource_week_view_weekend(app, admin_user):
+    resource = Resource.objects.create(label='Foo bar')
+    agenda = Agenda.objects.create(label='Agenda', kind='meetings')
+    agenda.resources.add(resource)
+    desk = Desk.objects.create(agenda=agenda, label='Desk')
+    MeetingType.objects.create(agenda=agenda, label='Bar', duration=30)
+    monday = 0
+    TimePeriod.objects.create(
+        desk=desk, weekday=monday, start_time=datetime.time(10, 0), end_time=datetime.time(18, 0)
+    )
+    week, year = '01', 2019
+
+    login(app)
+    resp = app.get('/manage/resource/%s/%s/week/%s/' % (resource.pk, year, week))
+    assert 'Sunday' not in resp.text
+    assert 'Saturday' not in resp.text
+    # Month starts a Tuesday, but monday is displayed
+    assert len(resp.pyquery.find('tbody tr:first th.weekday:empty')) == 0
+
+    week, year = 21, 2019  # month starts a Saturday
+    resp = app.get('/manage/resource/%s/%s/week/%s/' % (resource.pk, year, week))
+    assert len(resp.pyquery.find('tbody tr:first th.weekday:empty')) == 0
+
+    saturday = 5
+    timeperiod_sat = TimePeriod.objects.create(
+        desk=desk, weekday=saturday, start_time=datetime.time(10, 0), end_time=datetime.time(18, 0)
+    )
+    resp = app.get('/manage/resource/%s/%s/week/%s/' % (resource.pk, year, week))
+    assert 'Sunday' not in resp.text
+    assert 'Saturday' in resp.text
+    assert len(resp.pyquery.find('tbody tr:first th.weekday:empty')) == 0
+
+    sunday = 6
+    TimePeriod.objects.create(
+        desk=desk, weekday=sunday, start_time=datetime.time(10, 0), end_time=datetime.time(18, 0)
+    )
+    resp = app.get('/manage/resource/%s/%s/week/%s/' % (resource.pk, year, week))
+    assert 'Sunday' in resp.text
+    assert 'Saturday' in resp.text
+
+    timeperiod_sat.delete()
+    resp = app.get('/manage/resource/%s/%s/week/%s/' % (resource.pk, year, week))
+    assert 'Sunday' in resp.text
+    assert 'Saturday' in resp.text
+
+
+def test_resource_week_view_dst_change(app, admin_user):
+    resource = Resource.objects.create(label='Foo bar')
+    agenda = Agenda.objects.create(label='Agenda', kind='meetings')
+    agenda.resources.add(resource)
+    desk = Desk.objects.create(agenda=agenda, label='Desk')
+    meetingtype = MeetingType.objects.create(agenda=agenda, label='Bar', duration=30)
+    TimePeriod.objects.create(
+        desk=desk, weekday=0, start_time=datetime.time(9, 0), end_time=datetime.time(12, 0)
+    )
+
+    login(app)
+    # book some slots
+    with freezegun.freeze_time('2019-10-01'):
+        for start_datetime in [
+            make_aware(datetime.datetime(2019, 10, 2, 10, 0)),
+            make_aware(datetime.datetime(2019, 10, 29, 10, 0)),
+        ]:
+            event = Event.objects.create(
+                agenda=agenda,
+                places=1,
+                desk=desk,
+                meeting_type=meetingtype,
+                start_datetime=start_datetime,
+            )
+            event.resources.add(resource)
+            Booking.objects.create(event=event)
+
+    # check booked slots are similarly aligned
+    resp = app.get('/manage/resource/%s/2019/week/43/' % resource.pk)
+    assert resp.text.count('height:50.0%;top:100.0%') == 1
+
+
+def test_resource_week_view_januaries(app, admin_user):
+    resource = Resource.objects.create(label='Foo bar')
+    agenda = Agenda.objects.create(label='Agenda', kind='meetings')
+    agenda.resources.add(resource)
+    desk = Desk.objects.create(agenda=agenda, label='Desk')
+    TimePeriod(desk=desk, weekday=2, start_time=datetime.time(9, 0), end_time=datetime.time(12, 0)).save()
+
+    for year in range(2020, 2030):
+        date = datetime.date(year, 1, 1)
+        with freezegun.freeze_time(date):
+            login(app)
+            resp = app.get('/manage/resource/%s/%s/week/01/' % (resource.pk, date.year))
+            assert resp.text.count('<th></th>') == 1
+
+
+def test_resource_week_view_event_outside_timeperiod(app, admin_user):
+    middle_day = now().replace(day=15)
+    middle_day = middle_day + datetime.timedelta(days=4 - middle_day.weekday())
+    resource = Resource.objects.create(label='Foo bar')
+    agenda = Agenda.objects.create(label='Agenda', kind='meetings')
+    agenda.resources.add(resource)
+    desk = Desk.objects.create(agenda=agenda, label='Desk')
+    meetingtype = MeetingType.objects.create(agenda=agenda, label='Bar', duration=30)
+    login(app)
+
+    # no time period - no events
+    resp = app.get(
+        '/manage/resource/%s/%d/week/%s/' % (resource.pk, middle_day.year, middle_day.strftime('%W'))
+    )
+    assert 'No bookings this week.' in resp.text
+    assert 'div class="booking' not in resp.text
+
+    # book some slots
+    for hour, minute in [(9, 0), (17, 0)]:
+        event = Event.objects.create(
+            agenda=agenda,
+            places=1,
+            desk=desk,
+            meeting_type=meetingtype,
+            start_datetime=localtime(now()).replace(
+                day=middle_day.day - middle_day.weekday() + 2, hour=hour, minute=minute
+            ),
+        )
+        event.resources.add(resource)
+        Booking.objects.create(event=event)
+
+    # no time period - events are displayed
+    resp = app.get(
+        '/manage/resource/%s/%d/week/%s/' % (resource.pk, middle_day.year, middle_day.strftime('%W'))
+    )
+    assert resp.text.count('div class="booking') == 2
+
+    # events outside time period
+    TimePeriod.objects.create(
+        desk=desk, weekday=2, start_time=datetime.time(10, 0), end_time=datetime.time(16, 0)
+    )
+    resp = app.get(
+        '/manage/resource/%s/%d/week/%s/' % (resource.pk, middle_day.year, middle_day.strftime('%W'))
+    )
+    assert resp.text.count('div class="booking') == 2
+    assert 'Sunday' not in resp.text
+    assert 'Saturday' not in resp.text
+
+    # bookings are cancelled
+    Booking.objects.update(cancellation_datetime=now())
+    resp = app.get(
+        '/manage/resource/%s/%d/week/%s/' % (resource.pk, middle_day.year, middle_day.strftime('%W'))
+    )
+    assert resp.text.count('div class="booking') == 0
+
+    # create an event on saturday
+    Booking.objects.update(cancellation_datetime=None)  # reset
+    middle_day = now().replace(day=15)
+    middle_day = middle_day + datetime.timedelta(days=5 - middle_day.weekday())
+    event = Event.objects.create(
+        agenda=agenda,
+        places=1,
+        desk=desk,
+        meeting_type=meetingtype,
+        start_datetime=localtime(now()).replace(day=middle_day.day, hour=10, minute=0),
+    )
+    event.resources.add(resource)
+    Booking.objects.create(event=event)
+    resp = app.get(
+        '/manage/resource/%s/%d/week/%s/' % (resource.pk, middle_day.year, middle_day.strftime('%W'))
+    )
+    assert resp.text.count('div class="booking') == 3
+    assert 'Sunday' not in resp.text
+    assert 'Saturday' in resp.text
+    # bookings are cancelled
+    Booking.objects.update(cancellation_datetime=now())
+    resp = app.get(
+        '/manage/resource/%s/%d/week/%s/' % (resource.pk, middle_day.year, middle_day.strftime('%W'))
+    )
+    assert resp.text.count('div class="booking') == 0
+    # and a timeperiod
+    Booking.objects.update(cancellation_datetime=None)  # reset
+    TimePeriod.objects.create(
+        desk=desk, weekday=5, start_time=datetime.time(11, 0), end_time=datetime.time(12, 0)
+    )
+    resp = app.get(
+        '/manage/resource/%s/%d/week/%s/' % (resource.pk, middle_day.year, middle_day.strftime('%W'))
+    )
+    assert resp.text.count('div class="booking') == 3
+    assert 'Sunday' not in resp.text
+    assert 'Saturday' in resp.text
+
+    # create an event on sunday
+    middle_day = now().replace(day=15)
+    middle_day = middle_day + datetime.timedelta(days=6 - middle_day.weekday())
+    event = Event.objects.create(
+        agenda=agenda,
+        places=1,
+        desk=desk,
+        meeting_type=meetingtype,
+        start_datetime=localtime(now()).replace(day=middle_day.day, hour=10, minute=0),
+    )
+    event.resources.add(resource)
+    Booking.objects.create(event=event)
+    resp = app.get(
+        '/manage/resource/%s/%d/week/%s/' % (resource.pk, middle_day.year, middle_day.strftime('%W'))
+    )
+    assert resp.text.count('div class="booking') == 4
+    assert 'Sunday' in resp.text
+    assert 'Saturday' in resp.text
+    # bookings are cancelled
+    Booking.objects.update(cancellation_datetime=now())
+    resp = app.get(
+        '/manage/resource/%s/%d/week/%s/' % (resource.pk, middle_day.year, middle_day.strftime('%W'))
+    )
+    assert resp.text.count('div class="booking') == 0
+    # and a timeperiod
+    Booking.objects.update(cancellation_datetime=None)  # reset
+    TimePeriod.objects.create(
+        desk=desk, weekday=6, start_time=datetime.time(11, 0), end_time=datetime.time(12, 0)
+    )
+    resp = app.get(
+        '/manage/resource/%s/%d/week/%s/' % (resource.pk, middle_day.year, middle_day.strftime('%W'))
+    )
+    assert resp.text.count('div class="booking') == 4
+    assert 'Sunday' in resp.text
+    assert 'Saturday' in resp.text
+
+
+def test_week_view_resource_as_manager(app, manager_user):
+    agenda = Agenda.objects.create(label='Foo Bar', kind='meetings')
+    agenda.view_role = manager_user.groups.all()[0]
+    agenda.save()
+    resource = Resource.objects.create(label='Resource 1')
+    app = login(app, username='manager', password='manager')
+    today = datetime.date.today()
+    app.get('/manage/resource/%s/%d/week/%s/' % (resource.pk, today.year, today.strftime('%W')), status=403)
+
+
 @freezegun.freeze_time('2020-06-15')
 def test_resource_month_view(app, admin_user, get_proper_html_str):
     resource = Resource.objects.create(label='Foo bar')
@@ -261,7 +551,7 @@ def test_resource_month_view(app, admin_user, get_proper_html_str):
     today = datetime.date.today()
     with CaptureQueriesContext(connection) as ctx:
         resp = app.get('/manage/resource/%s/%s/%s/' % (resource.pk, today.year, today.month))
-        assert len(ctx.captured_queries) == 8
+        assert len(ctx.captured_queries) == 9
     assert resp.text.count('<div class="booking" style="height:33.0%;') == 2  # booking cells
     assert resp.pyquery.find('div.booking a').not_('.cancel')[0].text.strip() == 'booked'
     assert resp.pyquery.find('div.booking a').not_('.cancel')[1].text.strip() == "foo - bar's"
-- 
2.35.1

